/***************************************************************************
 *   Copyright (C) 2006 by LZ   *
 *      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef modcond_H
#define modcond_H
#include <twidgetgroup.h>
#include <qstring.h>
#include <QProcess>

#include "ui_modcond.h"

class modcond: public QWidget
{
    Q_OBJECT

public:
    modcond(QWidget * =NULL);
    ~modcond();
    QString modNum, oldModNum;
	// resize data structure
	struct w_buffer {
	  QWidget *w;
	  QFont font;
	  double x, y, width, height;
	};
	vector<w_buffer> ws_buffer;
	void resizeEvent( QResizeEvent * event );

public slots:
	void setMod(int mod);
	void updateLogs();
	void setK0();
	void setK1();
	void setK2();
	void setK3();
	void setK4();
	void setK5();
	void setK6();
	void setK7();
	void setK8();
	void setK9();
	void setK10();
	void setK11();
	void setK12();
	void setK13();
	void setK14();
	void setK15();
	void setK16();
	void setIndexMode(bool ok);

private:
    Ui::MainWindow ui;
    Tango::DeviceProxy *condServer;
    int connectDevice(QString dev, Tango::DeviceProxy **srv);
    void disconnectDevice();
	int configWidgets();
	void configK5();
	void configK16();
	void configKST();
	void configKXS();
	QString imgpath;
    int mySetColor(QPushButton *widget, const char *textColor, const char *backgroundColor);
    QProcess *cond_process;

};

#endif
