#include "tlistwidget.h"
#include <QTWatcher>

TListWidget::TListWidget(QWidget *parent) :
    QListWidget(parent)
{

}

void TListWidget::setItems(const QString &labels)
{
    QStringList items = labels.split('\n');
    clear();
    addItems(items);
}

void TListWidget::setSource(const QString& src)
{
    QTWatcher *w = findChild<QTWatcher *>();
    if (w) delete w;
    w = new QTWatcher(this);
    w->attach(this, SLOT(setItems(const QString&)));
    connect(w, SIGNAL(readOk(bool)), this, SLOT(readOk(bool)));
    connect(w, SIGNAL(connectionOk(bool)), this, SLOT(readOk(bool)));
    w->setSource(src);
}

void TListWidget::readOk(bool ok)
{
    setEnabled(ok);
    if(!ok)
        setItems("Read or connection error");
}
