/***************************************************************************
 *   Copyright (C) 2006 by LZ   *
 *      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// #include <QApplication>
#include <TApplication>
#include "modcond.h"
#include <X11/Xlib.h>
#include <QX11Info>
#include <tutil.h>
#include <QMessageBox>
#define CVSVERSION "$Name:  $"

int main( int argc, char ** argv ) {
    QString paramString, modNum;
    modNum = argv[1];
    QApplication a(argc, argv);
    a.setApplicationVersion(CVSVERSION);
    TUtil::instance()->setLoggingTarget(argv[0]);
    if (argc < 2) {
	    QMessageBox::information(0, "Error in startup parameters",
		QString("Error starting the program \"%1\"\nUsage:\n"
			"%1 modulator_number\n"
			"modulator_number: [00 || 01 || 02 .. 16]\n").arg(
				argv[0]).arg(argv[0]));
	    exit(EXIT_FAILURE);
    }
     modNum = argv[1];

    modcond mw;
    mw.show();

    /* register to window manager */
    Display *disp = QX11Info::display();
    Window root_win = (Window) mw.winId();
    XSetCommand(disp, root_win, argv, argc);
    return a.exec();
}
